# $Revision: 1.16 $, $Date: 2002/03/23 11:15:20 $
Summary:	Original AT&T Korn Shell
Summary(pl):	Oryginalny shell Korna z AT&T
Name:		ksh93
Version:	1.1
Release:	4
License:	AT&T Open Source
Group:		Applications/Shells
Source0:	http://www.research.att.com/~gsf/download/tgz/INIT.2001-01-01.0000.tgz
Source1:	http://www.research.att.com/~gsf/download/tgz/ast-base.2001-01-01.0000.tgz
Source2:	%{name}-ldhack.sh
Patch0:		%{name}-build.patch
Patch1:		%{name}-echo-e.patch
Patch2:		%{name}-login.patch
URL:		http://www.kornshell.com/
%if %{!?_without_static:1}%{?_without_static:0}
BuildRequires:	glibc-static
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
KSH-93 is the most recent version of the KornShell Language described
in "The KornShell Command and Programming Language," by Morris Bolsky
and David Korn of AT&T Bell Laboratories, ISBN 0-13-182700-6. The
KornShell is a shell programming language, which is upward compatible
with "sh" (the Bourne Shell), and is intended to conform to the IEEE
P1003.2/ISO 9945.2 Shell and Utilities standard. KSH-93 provides an
enhanced programming environment in addition to the major
command-entry features of the BSD shell "csh". With KSH-93,
medium-sized programming tasks can be performed at shell-level without
a significant loss in performance. In addition, "sh" scripts can be
run on KSH-93 without modification.

%description -l pl
KSH-93 jest najwiesz wersj jzyka KornShell opisanego przez
Morrisa Blolsky'ego i Davida Korna z AT&T Bell Laboratories. Shell
Korna jest kompatybilny z "sh" (shellem Bourne) i ma by zgodny z
norm IEEE P1003.2/ISO 9945.2.

%package static
Summary:	Statically linked Korn Shell
Summary(pl):	Statycznie zlinkowany shell Korna
Group:		Applications/Shells
Requires:	%{name}

%description static
KSH-93 is the most recent version of the KornShell Language described
in "The KornShell Command and Programming Language," by Morris Bolsky
and David Korn of AT&T Bell Laboratories, ISBN 0-13-182700-6. The
KornShell is a shell programming language, which is upward compatible
with "sh" (the Bourne Shell), and is intended to conform to the IEEE
P1003.2/ISO 9945.2 Shell and Utilities standard. KSH-93 provides an
enhanced programming environment in addition to the major
command-entry features of the BSD shell "csh". With KSH-93,
medium-sized programming tasks can be performed at shell-level without
a significant loss in performance. In addition, "sh" scripts can be
run on KSH-93 without modification.

This packege contains statically linked version of ksh93.

%description static -l pl
KSH-93 jest najwiesz wersj jzyka KornShell opisanego przez
Morrisa Blolsky'ego i Davida Korna z AT&T Bell Laboratories. Shell
Korna jest kompatybilny z "sh" (shellem Bourne) i ma by zgodny z
norm IEEE P1003.2/ISO 9945.2.

Ten pakiet zawiera statycznie zlinkowan wersj ksh93.

%prep
%setup -q -c -a1
%patch0 -p1
%patch1 -p1
%patch2 -p1
install -m755 %{SOURCE2} ldhack.sh
touch lib/package/gen/ast.license.accepted
rm -f src/cmd/ksh93/Mamfile

# at some moment build stops using CCFLAGS - fix it:
(cd src/cmd/nmake
sed -e 's@CC_OPTIMIZE=\$optimize@CC_OPTIMIZE="%rpmcflags"@' make.probe > make.probe.n
mv -f make.probe.n make.probe
)

%build
LC_ALL=POSIX; export LC_ALL

# Yes this sucks, but that's the way (I'm too lazy to fix this stuff)
CCFLAGS="%rpmcflags" LD="`pwd`/ldhack.sh" ./bin/package make ksh93 || :
CCFLAGS="%rpmcflags" LD="`pwd`/ldhack.sh" ./bin/package make ksh93 || :
CCFLAGS="%rpmcflags" LD="`pwd`/ldhack.sh" ./bin/package make ksh93

cd arch/*/src/cmd/ksh93
%{__cc} -o ksh93 pmain.o -L../../../lib -lksh \
	../../../lib/libdll.a -ldl ../../../lib/libcmd.a \
	../../../lib/libast.a -lm

%if %{!?_without_static:1}%{?_without_static:0}
%{__cc} -static -o ksh93.static pmain.o -L../../../lib -lksh \
	../../../lib/libdll.a -ldl ../../../lib/libcmd.a \
	../../../lib/libast.a -lm
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_mandir}/man1,/lib,/bin,%{_sysconfdir}}

install arch/*/src/cmd/ksh93/ksh93 $RPM_BUILD_ROOT/bin
%if %{!?_without_static:1}%{?_without_static:0}
install arch/*/src/cmd/ksh93/ksh93.static $RPM_BUILD_ROOT/bin
%endif
install arch/*/src/cmd/ksh93/libksh.so.* $RPM_BUILD_ROOT/lib
install arch/*/man/man1/sh.1 $RPM_BUILD_ROOT%{_mandir}/man1/ksh93.1

%if %{?_with_binsh:1}%{!?_with_binsh:0}
echo ".so ksh93.1" > $RPM_BUILD_ROOT%{_mandir}/man1/sh.1
ln -sf ksh93 $RPM_BUILD_ROOT/bin/sh
%endif

cp -f lib/package/LICENSES/ast LICENSE
gzip -9nf LICENSE

cd src/cmd/ksh93
mv -f OBSOLETE OBSOLETE.mm
groff -mm -Tascii OBSOLETE.mm > OBSOLETE
groff -mm -Tascii sh.memo > memo.txt
groff -mm -Tascii PROMO.mm > PROMO

gzip -9nf COMPATIBILITY README RELEASE* builtins.mm OBSOLETE memo.txt PROMO

%post
/sbin/ldconfig
if [ ! -f /etc/shells ]; then
	echo "/bin/ksh93" > /etc/shells
else
	while read SHNAME; do
        	if [ "$SHNAME" = "/bin/ksh93" ]; then
                	HAS_KSH=1
	        fi
%if %{?_with_binsh:1}%{!?_with_binsh:0}
        	if [ "$SHNAME" = "/bin/sh" ]; then
                	HAS_SH=1
	        fi
%endif
	done < /etc/shells
	[ -n "$HAS_KSH" ] || echo "/bin/ksh93" >> /etc/shells
%if %{?_with_binsh:1}%{!?_with_binsh:0}
	[ -n "$HAS_SH" ] || echo "/bin/sh" >> /etc/shells
%endif
fi

%post static
if [ ! -f /etc/shells ]; then
	echo "/bin/ksh93.static" > /etc/shells
else
	while read SHNAME; do
        	if [ "$SHNAME" = "/bin/ksh93.static" ]; then
                	HAS_KSH_STATIC=1
	        fi
	done < /etc/shells
	[ -n "$HAS_KSH_STATIC" ] || echo "/bin/ksh93.static" >> /etc/shells
fi

%preun
if [ "$1" = "0" ]; then
	while read SHNAME; do
		[ "$SHNAME" = "/bin/ksh93" ] ||\
%if %{?_with_binsh:1}%{!?_with_binsh:0}
		[ "$SHNAME" = "/bin/sh" ] ||\
%endif
		echo "$SHNAME"
	done < /etc/shells > /etc/shells.new
	mv -f /etc/shells.new /etc/shells
fi

%preun static
if [ "$1" = "0" ]; then
	while read SHNAME; do
		[ "$SHNAME" = "/bin/ksh93.static" ] ||\
		echo "$SHNAME"
	done
	mv -f /etc/shells.new /etc/shells
fi

%postun
/sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc src/cmd/ksh93/*.gz LICENSE.gz

%attr(755,root,root) /bin/ksh93
%attr(755,root,root) /lib/libksh.so.*

%{_mandir}/man1/*

%if %{?_with_binsh:1}%{!?_with_binsh:0}
%attr(755,root,root) /bin/sh
%endif

%if %{!?_without_static:1}%{?_without_static:0}
%files static
%defattr(644,root,root,755)
%attr(755,root,root) /bin/ksh93.static
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld.org.pl>
All persons listed below can be reached at <cvs_login>@pld.org.pl

$Log: ksh93.spec,v $
Revision 1.16  2002/03/23 11:15:20  kloczek
- release 4.

Revision 1.15  2002/02/23 02:59:11  kloczek
- adapterized.

Revision 1.14  2002/02/22 23:29:09  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.13  2002/01/22 22:34:52  qboosh
- the same, upper case

Revision 1.12  2002/01/22 22:32:42  qboosh
- typo

Revision 1.11  2002/01/18 02:13:35  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.10  2001/06/21 15:56:00  baggins
- release 3
- added login patch (adds -l option)

Revision 1.9  2001/06/15 16:02:24  baggins
- added with_binsh to conditionaly build ksh93 as /bin/sh

Revision 1.8  2001/06/04 14:44:45  baggins
- proper _without_static bcond

Revision 1.7  2001/05/22 09:06:26  wiget
switch to new conditional builds macros (bcond_on_ -> _with_/bcond_off_ -> _without_); no release changes only simple s/// perfored

Revision 1.6  2001/05/21 20:19:45  qboosh
- use rpmcflags during all build process
- pl translations
- release 2

Revision 1.5  2001/05/14 14:21:59  baggins
- release 1
- added LICENSE to %%doc
- added echo-e patch

Revision 1.4  2001/05/13 12:59:24  misiek
set LC_ALL to POSIX in %%build. Need to compile it properly in localized
enviroment.

Revision 1.3  2001/05/13 04:43:34  kloczek
- added glibc-static to BuildRequires.

Revision 1.2  2001/05/13 04:41:10  kloczek
- spec adapterized and added using %%{__cc} macro.

Revision 1.1  2001/05/13 03:07:36  baggins
- the one, the only, the original, written by David Korn - The Korn Shell
